package com.nisum.poc.springwebfluxdemo.controller;


import com.nisum.poc.springwebfluxdemo.service.BookService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


import com.nisum.poc.springwebfluxdemo.entity.Book;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/api")

public class BookController {

    private static final Logger logger = LoggerFactory.getLogger(BookController.class);


    @Autowired
    public BookService bookService;


   @PostMapping("/createBook")
    public  Mono<Book> create(@RequestBody Book book){
       logger.info("CreateBook method called");
      return  bookService.create(book);


    }

   @GetMapping("/getAllBook")
    public Flux<Book> getAllBook(){
       logger.info("getAllBook method called");
       return bookService.getAllBooks();
    }

    @GetMapping("/getSingleBook/{bookId}")
    public Mono<Book> getSingleBook(@PathVariable Integer bookId){
        logger.info("getSingleBook method called");
       return  bookService.getBook(bookId);
    }

   @PutMapping("/updateBook/{bookId}")
    public Mono<Book> update(@RequestBody Book book,@PathVariable Integer bookId){
       logger.info("update method called");
       return bookService.updateBook(book,bookId);
    }

    @DeleteMapping("/deleteBook/{bookId}")
    public Mono<Void> delete(@PathVariable Integer bookId){
        logger.info("delete method called");
        return   bookService.deleteBook(bookId);
    }



}
